



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>进程控制fork vfork，父子进程，vfork保证子进程先运行</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">进程控制fork vfork，父子进程，vfork保证子进程先运行</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 04:43:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>主要函数：</p>
<p>fork 用于创建一个新进程</p>
<p>exit 用于终止进程</p>
<p>exec 用于执行一个程序</p>
<p>wait 将父进程挂起，等待子进程结束</p>
<p>getpid 获取当前进程的进程ID</p>
<p>nice 改变进程的优先级</p>
<p><em>---------------------------------</em></p>
<p><em>孤儿进程：</em></p>
<p><em>如果一个子进程的父进程先于子进程结束，子进程就成为一个孤儿进程，他由init进程收养，成为init进程的子进程。</em></p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;unistd.h&gt;

int main()<br />
{

    pid_t pid;<br />
    pid = fork();

    switch( pid )<br />
    {<br />
        case :<br />
        {<br />
            while()<br />
            {<br />
                printf("child pid:%d, parent pid:%d\n", getpid(), getppid());<br />
                sleep();<br />
            }<br />
        }<br />
        case -:<br />
        {<br />
            printf("create child process error\n");<br />
            exit(-);<br />
        }<br />
        default:<br />
        {<br />
            sleep();<br />
            printf("I am parent,pid:%d\n", getpid());<br />
            exit();<br />
        }

    }

    return ;

}</pre>
</div>
<p>child pid:9670, parent pid:9669<br />child pid:9670, parent pid:9669<br />child pid:9670, parent pid:9669<br />I am parent,pid:9669<br />root@wilson-software:~/Project/xa# child pid:9670, parent pid:1<br />child pid:9670, parent pid:1<br />child pid:9670, parent pid:1<br />child pid:9670, parent pid:1<br />child pid:9670, parent pid:1<br />child pid:9670, parent pid:1</p>
<p>从输出结果来看，父进程停止后，子进程变成了孤儿进程，此时子进程的父进程ID 是 1，</p>
<p>（init进程的进程ID值始终是1）<em>由init进程收养。</em></p>
<p><em>------------------------------------------------------------------------------</em></p>
<p><em>vfork函数创建一个子进程时，操作系统并不将父进程的地址空间完全复制到子进程，用vfork函数创建的子进程共享父进程的地址空间，</em></p>
<p><em>也就是说子进程完全运行在父进程的地址空间上。子进程对该地址空间中任何数据的修改同样为父进程所见。</em></p>
<p><em>使用fork创建一个子进程时，哪个进程先执行取决于系统的调度。</em></p>
<p><em>而vfork创建一个子进程时，vfork保证子进程先运行，子进程调用exec或者exit之前父进程处于阻塞等待状态。</em></p>
<p><em>如果在调用<em>exec或者exit之前子进程要依赖父进程的某个行为，就会导致死锁。</em></em></p>
<p><em><em>如果创建子进程的目的只是为了调用exec执行某个程序，那么fork过程中子进程对父进程地址空间的复制将会是一个多余的过程。</em></em></p>
<p><em><em>vfork不会拷贝父进程的地址空间，这大大减小了系统开销。</em></em></p>
<p><em><em>使用<em><em>vfork时要谨慎，最好不要允许子进程修改与父进程共享的全局变量和局部变量</em></em></em></em></p>
<p>-------------------------------------------------------------------------------------------------------------------------------------------------</p>
<p>父子进程结束的先后顺序不同会产生不同的结果：</p>
<p>父进程先退出，子进程后退出，则系统会让init进程接管子进程。</p>
<p>当子进程先退出，而父进程又没有调用wait函数等待子进程结束，子进程进入僵死状态，并且会一直保持下去除非系统重启。子进程处于僵死状态时，内核只保存该进程的</p>
<p>一些必要信息以备父进程所需。此时子进程始终占用着资源，同时也减少了系统可以创建的最大进程数。如果子进程先于父进程结束，并且父进程调用了wait或waitpid函数，</p>
<p>则父进程会等待子进程。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyxj228.html">canvas练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldk1k9.html">html、css、javascript、JSP 、xml学习顺序应该是怎样的呢？</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpxpzq.html">如何处理json字符转换为字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7rv718.html">通过微信查找SAP TCODE代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wdl6lq.html">Uva 725 除法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2jxj8.html">ociuldr 支持分多个数据文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y33r5q.html">【转】跟着开涛学SpringMVC</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xmr3z9.html">Eclipse vim插件安装使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwkrl8.html">SqlServer中的数据类型UniqueIdentifier</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zk0m59.html">Windows窗口的尺寸和位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p2yw48.html">冲刺NO&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyv17mq.html">51NOD 1185 威佐夫游戏 V2&lpar;威佐夫博弈&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1e23l9.html">mysql关联、子查询索引优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2y579.html">【2&period;0】SpringBoot连接MySql 8&period;0的url设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j7eynq.html">git 在本地拉取远程分支的代码（并不做提交操作）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzxw69.html">HTTP协议（TCP&sol;IP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o10l7lq.html">node 读取多个文件、合并多个文件、读写多个文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93podp08.html">地球椭球体&lpar;Ellipsoid&rpar;、大地基准面&lpar;Datum&rpar;及地图投影&lpar;Projection&rpar;三者的基本概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjjv3vq.html">CI框架 -- 核心文件 之 Hooks&period;php</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkv7318.html">CentOS下mysql安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdjdg2jq.html">elasticsearch分词器ik</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkre0n8.html">20165211 2017-2018-2 《Java程序设计》第3周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv4omxq.html">MVC  视图的简单学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv4xwjq.html">【angular2&plus;typeScript&plus;ng-zorro】Carousel 走马灯的左右方向控件实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/902jlrmq.html">Python3基础 global 使函数中的局部变量升格为全局变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/9637gmy9.html">Python3基础 issubclass 判断基类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2oxgv8.html">linux下递归列出目录下的所有文件名（不包括目录）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vpn54q.html">FJNUOJ Yehan&rsquo;s hole（容斥求路径数 &plus; 逆元）题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn2kr2q.html">hdu 6180 Schedule</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnypddq.html">RMQ 区间最大值  最小值查询</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
